Bugzilla (bugzilla.redhat.com) will be under maintenance for infrastructure upgrades and will not be available on July 31st between 12:30 AM - 05:30 AM UTC. We appreciate your understanding and patience. You can follow status.redhat.com for details.
Bug 1346018 - Review Request: jmake - Make utility for large Java projects
Summary: Review Request: jmake - Make utility for large Java projects
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: gil cattaneo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-06-13 16:47 UTC by Raphael Groner
Modified: 2016-07-24 21:49 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-07-18 18:24:49 UTC
Type: ---
puntogil: fedora-review+


Attachments (Terms of Use)

Description Raphael Groner 2016-06-13 16:47:39 UTC
Spec URL: https://raphgro.fedorapeople.org/review/java/jmake/jmake.spec
SRPM URL: https://raphgro.fedorapeople.org/review/java/jmake/jmake-1.3.8.1-1.20150716git7761ee3.fc24.src.rpm

Description: Make utility for large Java projects
JMake (formerly Javamake) is a tool for Java programmers to make
compiling large projects consisting of many packages and source
files easy. It is similar in purpose to the make utility familiar
to C programmers, except it requires no user configuration.

Fedora Account System Username: raphgro

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=14474428

Comment 1 Raphael Groner 2016-06-13 17:40:45 UTC
Spec URL: https://raphgro.fedorapeople.org/review/java/jmake/jmake.spec
SRPM URL: https://raphgro.fedorapeople.org/review/java/jmake/jmake-1.3.8.8-1.20150716git7761ee3.fc24.src.rpm

- fixed version
- try to fix rpmlint:

$ rpmlint SPECS/jmake.spec SRPMS/jmake-1.3.8.8-1.20150716git7761ee3.fc24.src.rpm RPMS/noarch/jmake-1.3.8.8-1.20150716git7761ee3.fc24.noarch.rpm RPMS/noarch/jmake-javadoc-1.3.8.8-1.20150716git7761ee3.fc24.noarch.rpm 
jmake.noarch: W: unexpanded-macro Provides mvn(org.pantsbuild:jmake:pom:) = %VERSION% %VERSION
jmake.noarch: W: no-manual-page-for-binary jmake
3 packages and 1 specfiles checked; 0 errors, 2 warnings.

- No idea how to set a value for %VERSION%.
- Help output is not compatible with help2man.

Comment 2 gil cattaneo 2016-06-13 23:10:32 UTC
hi
you must set:
javac.source, javac.target, default.javac.source and default.javac.target to 1.6
and you must sure which javadoc.encoding and source.encoding is set to UTF-8
see nbproject/build-impl.xml
<property name="default.javac.source" value="1.4"/>
<property name="default.javac.target" value="1.4"/>

e.g. 
ant -DVERSION=%{srcversion} \
 -Ddefault.javac.source=1.6 \
 -Ddefault.javac.target=1.6 \
 ...

(In reply to Raphael Groner from comment #1)
> jmake.noarch: W: unexpanded-macro Provides mvn(org.pantsbuild:jmake:pom:) =
> %VERSION% %VERSION
> jmake.noarch: W: no-manual-page-for-binary jmake
> 3 packages and 1 specfiles checked; 0 errors, 2 warnings.
> 
> - No idea how to set a value for %VERSION%.
sed -i "s/%VERSION%/%version/" jmake.pom ?
and
sed -i "s/%TAG%/%commit0/" jmake.pom

Comment 3 Raphael Groner 2016-06-14 07:26:39 UTC
That's a cool idea to use ant properties instead of sed patching. I'll try soon.

Comment 4 Raphael Groner 2016-06-14 16:05:40 UTC
Fixed. Thanks!

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=14487921

> rpmlint SPECS/jmake.spec SRPMS/jmake-1.3.8.8-1.20150716git7761ee3.fc24.src.rpm RPMS/noarch/jmake-1.3.8.8-1.20150716git7761ee3.fc24.noarch.rpm RPMS/noarch/jmake-javadoc-1.3.8.8-1.20150716git7761ee3.fc24.noarch.rpm                                                          
jmake.noarch: W: no-manual-page-for-binary jmake
3 packages and 1 specfiles checked; 0 errors, 1 warnings.

Comment 5 gil cattaneo 2016-06-14 17:14:25 UTC
Ops ...
please, change:
%mvn_artifact %{name}.pom

%install
%mvn_artifact org.pantsbuild.%{name}:%{name}:%{version} dist/%{name}.jar

in
....
%endif

%install
%mvn_artifact %{name}.pom dist/%{name}.jar

Comment 6 gil cattaneo 2016-06-14 17:16:48 UTC
... and also ...
ant \
%if 0%{?fedora}
 -Ddefault.javac.source=1.8 -Ddefault.javac.target=1.8
%else
 -Ddefault.javac.source=1.7 -Ddefault.javac.target=1.7
%endif

with

ant -Ddefault.javac.source=1.7 -Ddefault.javac.target=1.7

should be enough ...

Comment 7 Raphael Groner 2016-06-14 17:55:17 UTC
ok, fixed.

Comment 8 gil cattaneo 2016-06-14 19:34:24 UTC
... sorry forgot ...
please, remove
Requires:       java-headless 
... for us is useless

Comment 9 Raphael Groner 2016-06-28 12:08:49 UTC
ok, fixed.

Comment 10 gil cattaneo 2016-06-28 12:37:42 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 41 files have unknown license. Detailed
     output of licensecheck in /home/gil/1346018-jmake/licensecheck.txt
 Only these files are without license headers. Please, report to upsteram
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/classfilereader/Parent.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/ClassFileReaderTest.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/CompileResult.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/PCDManagerTest.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/PCDSerializationTest.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/TestPCDUtils.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/UtilsTest.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/packageinfo/package-info.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase1/A.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase1/B.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase1/C.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase2/orig-files/with-extra
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase2/orig-files/without-extra
 
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
     Note: Multiple Release: tags found
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in jmake-
     javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[?]: Package does not include license text files separate from upstream.
 Why use this pre-release? Please, add a comment in the spec file
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: jmake-1.3.8.8-1.20150716git7761ee3.fc25.noarch.rpm
          jmake-javadoc-1.3.8.8-1.20150716git7761ee3.fc25.noarch.rpm
          jmake-1.3.8.8-1.20150716git7761ee3.fc25.src.rpm
jmake.noarch: W: no-manual-page-for-binary jmake
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
jmake.noarch: W: no-manual-page-for-binary jmake
2 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
jmake-javadoc (rpmlib, GLIBC filtered):
    javapackages-tools

jmake (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools



Provides
--------
jmake-javadoc:
    jmake-javadoc

jmake:
    jmake
    mvn(org.pantsbuild:jmake)
    mvn(org.pantsbuild:jmake:pom:)



Source checksums
----------------
https://github.com/pantsbuild/jmake/archive/7761ee3e1537ccc61820c0d30061eb09edaf1c93.tar.gz#/jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93.tar.gz :
  CHECKSUM(SHA256) this package     : 5f1c1364c14bf2b6d27e3216bbfcdb13570fabf3711656b73f5e9ac93f02510f
  CHECKSUM(SHA256) upstream package : 5f1c1364c14bf2b6d27e3216bbfcdb13570fabf3711656b73f5e9ac93f02510f


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1346018 --plugins Java -m fedora-rawhide-i386
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 11 gil cattaneo 2016-06-28 12:39:43 UTC
Issues:

[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 41 files have unknown license. Detailed
     output of licensecheck in /home/gil/1346018-jmake/licensecheck.txt
 Only these files are without license headers. Please, report to upsteram
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/classfilereader/Parent.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/ClassFileReaderTest.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/CompileResult.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/PCDManagerTest.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/PCDSerializationTest.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/TestPCDUtils.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/org/pantsbuild/jmake/UtilsTest.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/packageinfo/package-info.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase1/A.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase1/B.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase1/C.java
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase2/orig-files/with-extra
 jmake-7761ee3e1537ccc61820c0d30061eb09edaf1c93/test/testcase2/orig-files/without-extra

Comment 12 Raphael Groner 2016-07-02 16:32:38 UTC
Thanks. Reported license issue to upstream.
https://github.com/pantsbuild/jmake/issues/24

Anyways, that should not block the review. Package license is for built binary, we see questionable test files only. The License: field refers to the licenses of the contents of the binary rpm.

Comment 13 gil cattaneo 2016-07-02 17:04:36 UTC
(In reply to Raphael Groner from comment #12)
> Thanks. Reported license issue to upstream.
> https://github.com/pantsbuild/jmake/issues/24
> 
> Anyways, that should not block the review. Package license is for built
> binary, we see questionable test files only. The License: field refers to
> the licenses of the contents of the binary rpm.

Approved

Comment 14 Raphael Groner 2016-07-02 17:50:41 UTC
Thanks for the review!

Comment 15 Gwyn Ciesla 2016-07-05 16:13:04 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/jmake

Comment 16 Fedora Update System 2016-07-07 11:14:27 UTC
jmake-1.3.8.8-2.20150716git7761ee3.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-078696f754

Comment 17 Fedora Update System 2016-07-07 11:14:34 UTC
jmake-1.3.8.8-2.20150716git7761ee3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-bbb939d86b

Comment 18 Fedora Update System 2016-07-10 03:18:36 UTC
jmake-1.3.8.8-2.20150716git7761ee3.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-078696f754

Comment 19 Fedora Update System 2016-07-10 15:59:37 UTC
jmake-1.3.8.8-2.20150716git7761ee3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-bbb939d86b

Comment 20 Fedora Update System 2016-07-18 18:24:47 UTC
jmake-1.3.8.8-2.20150716git7761ee3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2016-07-24 21:49:38 UTC
jmake-1.3.8.8-2.20150716git7761ee3.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.